import type { transport } from "../../client/type";
import { BridgeBasic } from "../Basic";
export declare enum ACTION {
    SHOW_SAVEBAR = "showSaveBar",
    HIDE_SAVEBAR = "hideSaveBar",
    DISCARD_SAVEBAR = "savebarCancelAction",
    SAVE_SAVEBAR = "savebarSaveAction",
    LOADING_SAVEBAR = "savebarLoading",
    CANCEL_LOADING_SAVEBAR = "savebarCancelLoading",
    EXIT_SAVEBAR_COMFIRM = "leaveCurrentPage",
    GET_STATUS = "getStatus",
    CANCEL_SAVEBAR_COMFIRM = "cancelSavebarComfirm"
}
export type TSaveBarOption = {
    loading?: boolean;
    withLangField?: boolean;
    formType?: 'edit' | 'add';
    onFinishText?: string;
    ignoreExitFun?: boolean;
    formLayoutEditing?: boolean;
    disabledBeforeFieldsChange?: boolean;
    disabled?: boolean;
    ignoreBlockRoutes?: string[];
    getHandleOfFaild?: (fun: (...args: any[]) => void) => void;
    showNotification?: boolean;
    hideSubmit?: boolean;
    destroyOnReset?: boolean;
    hideDivider?: boolean;
    usePageHeader?: boolean;
};
export type TExitComfimOption = {
    okText?: string;
    cancelText?: string;
    content?: string;
    reservedPage?: boolean;
};
declare class SaveBar extends BridgeBasic {
    constructor(app: transport);
    setLoading: (loading: boolean) => void;
    show: (option?: TSaveBarOption) => void;
    hide: () => void;
    exitComfirm: (option: TExitComfimOption) => Promise<void>;
    getStatus: () => Promise<{
        isEditing: boolean;
    }>;
}
export declare function create(app: transport): SaveBar;
export {};
