import { transport } from '../../client/type';
import { ADMIN_SECTION } from '../../enum/ActionEnum';
import { BridgeBasic } from '../Basic';
import type { TnavagateParam, IRedirectParam } from './type';
export declare enum ACTION {
    REDIRECT = "redirect",
    ROUTER_REDIRECT = "routerRedirect",
    ROUTER_TO_SPECIFIED_PAGE = "specifiedpage"
}
declare class Redirect extends BridgeBasic {
    localOrigin: string;
    constructor(app: transport);
    /**
     *
     * @param url
     */
    replaceTo: (url: string) => void;
    /**
     *
     * @param url
     */
    routerTo: (url: string) => void;
    /**
     *
     * @param params
     * newContext
     * url
     */
    navigate: (params: TnavagateParam) => void;
    /**
     *
     * @param section admin specified page
     * @param params
     */
    ToAdminPage: (section: ADMIN_SECTION, params?: IRedirectParam) => void;
}
declare function create(app: transport): Redirect;
export { create, Redirect, ADMIN_SECTION };
