import { ACTION as CameraAction } from '../actions/Camera';
import { ACTION as MessageAction } from '../actions/Message';
import { ACTION as ModalAction } from '../actions/Modal';
import { ACTION as OauthAction } from '../actions/Oauth';
import { ACTION as PosAction } from '../actions/Pos';
import { ACTION as SaveBarAction } from '../actions/SaveBar';
import { ACTION as SessionAction } from '../actions/Session';
import { ACTION as ShareAction } from '../actions/Share';
import { ACTION as redirectAction } from '../actions/redirect';
import { ACTION as FullScreenAction } from '../actions/FullScreen';
import { ACTION as LoadingAction } from '../actions/Loading';
import { ACTION as UnstablePickerAction } from '../actions/UnstablePicker';
import { ACTION as ResourcePickerAction } from '../actions/ResourcePicker';
/**
 * Defines the functions that Actions implement in the appstore
 */
export interface ActionsInterFace {
    /**
     * Route jump
     */
    redirect: () => void;
    /**
     * page redirect
     */
    routerRedirect: () => void;
    /**
     * Open the dialog
     */
    openModal: () => void;
    /**
     * Open the message
     */
    message: () => void;
}
export declare enum ADMIN_SECTION {
    SALES = "sales",
    OAUTH = "oauth",
    ORDERS = "orders",
    PRODUCTS = "products",
    CUSTOMER = "customer",
    CATEGORIES = "categories",
    PACKAGEPURCHASE = "packagepurchase"
}
export type ACTION = CameraAction | MessageAction | ModalAction | OauthAction | PosAction | SaveBarAction | SessionAction | ShareAction | redirectAction | FullScreenAction | LoadingAction | UnstablePickerAction | ResourcePickerAction;
